diff --git a/src/backend/access/heap/heapam_handler.c b/src/backend/access/heap/heapam_handler.c
index 1096d9d4dc9..1eec39e6ebb 100644
--- a/src/backend/access/heap/heapam_handler.c
+++ b/src/backend/access/heap/heapam_handler.c
@@ -50,11 +50,24 @@
 #include "utils/injection_point.h"
 #include "utils/rel.h"
 #include "utils/tuplesort.h"
-
-static Snapshot finalize_block_range(ChangeContext *chgcxt, BlockNumber cur,
-									 BlockNumber start, BlockNumber *end_p);
+#include "utils/wait_event_types.h"
+
+static void update_identity_index(ChangeContext *chgcxt,
+								  BlockNumber range_start,
+								  BlockNumber range_end);
+static Snapshot finalize_block_range(Relation rel_old, Relation rel_dst,
+									 TransactionId oldest_xmin,
+									 TransactionId xid_cutoff,
+									 MultiXactId multi_cutoff,
+									 ChangeContext *chgcxt, BlockNumber cur,
+									 BlockNumber start, BlockNumber *end_p,
+									 RewriteState *rwstate_p,
+									 BlockNumber *range_start_dst_p);
 static void reform_and_rewrite_tuple(TupleTableSlot *src, TupleTableSlot *reform,
 									 RewriteState rwstate);
+static void heap_insert_for_repack(ChangeContext *chgcxt, TupleTableSlot *src,
+								   TupleTableSlot *reform,
+								   RewriteState rwstate);
 
 static bool SampleHeapTupleVisible(TableScanDesc scan, Buffer buffer,
 								   HeapTuple tuple,
@@ -199,7 +212,8 @@ heapam_tuple_complete_speculative(Relation relation, TupleTableSlot *slot,
 }
 
 static TM_Result
-heapam_tuple_delete(Relation relation, ItemPointer tid, CommandId cid,
+heapam_tuple_delete(Relation relation, ItemPointer tid, TransactionId xid,
+					CommandId cid,
 					uint32 options, Snapshot snapshot, Snapshot crosscheck,
 					bool wait, TM_FailureData *tmfd)
 {
@@ -208,7 +222,7 @@ heapam_tuple_delete(Relation relation, ItemPointer tid, CommandId cid,
 	 * the storage itself is cleaning the dead tuples by itself, it is the
 	 * time to call the index tuple deletion also.
 	 */
-	return heap_delete(relation, tid, cid, options, crosscheck, wait,
+	return heap_delete(relation, tid, xid, cid, options, crosscheck, wait,
 					   tmfd);
 }
 
@@ -610,25 +624,30 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
 	Snapshot	snapshot = NULL;
 	BlockNumber range_start = InvalidBlockNumber;
 	BlockNumber range_end = InvalidBlockNumber;
+	BlockNumber range_start_new = InvalidBlockNumber;
+	BlockNumber range_end_new = InvalidBlockNumber;
+	Relation	rel_dst;
 
 	/* Remember if it's a system catalog */
 	is_system_catalog = IsSystemRelation(OldHeap);
 
+	/* Determine the destination for the tuples. */
+	if (!concurrent || chgcxt->cc_dest_aux == NULL)
+		rel_dst = NewHeap;
+	else
+		rel_dst = chgcxt->cc_dest_aux->rel;
+
 	/*
 	 * Valid smgr_targblock implies something already wrote to the relation.
 	 * This may be harmless, but this function hasn't planned for it.
 	 */
-	Assert(RelationGetTargetBlock(NewHeap) == InvalidBlockNumber);
+	Assert(RelationGetTargetBlock(rel_dst) == InvalidBlockNumber);
 
 	/*
-	 * In non-concurrent mode, initialize the rewrite operation.  This is not
-	 * needed in concurrent mode.
+	 * Initialize the rewrite operation.
 	 */
-	if (!concurrent)
-		rwstate = begin_heap_rewrite(OldHeap, NewHeap, OldestXmin,
-									 *xid_cutoff, *multi_cutoff);
-	else
-		rwstate = NULL;
+	rwstate = begin_heap_rewrite(OldHeap, rel_dst, OldestXmin, *xid_cutoff,
+								 *multi_cutoff, concurrent);
 
 	/*
 	 * Set up sorting if wanted. CONCURRENTLY sorts the tuple w/o tuplesort,
@@ -700,6 +719,7 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
 		{
 			range_start = heapScan->rs_startblock;
 			range_end = range_start + repack_pages_per_snapshot;
+			range_start_new = RelationGetNumberOfBlocks(rel_dst);
 		}
 	}
 
@@ -717,24 +737,40 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
 		InvalidateCatalogSnapshot();
 
 		/*
-		 * As there is no snapshot, our xmin should be invalid now.
-		 *
-		 * XXX xid can still be valid. The next patches in the series fix
-		 * that.
+		 * As there is no snapshot, our xmin should be invalid now. xid should
+		 * be invalid too because our transactions didn't have to do any
+		 * writes yet.
 		 */
 		Assert(!TransactionIdIsValid(MyProc->xmin));
+		Assert(!TransactionIdIsValid(MyProc->xid));
 
 		/*
 		 * Wait until the worker has the initial snapshot and retrieve it.
 		 */
 		snapshot = repack_get_snapshot(chgcxt);
+		chgcxt->cc_last_snapshot_xmin = snapshot->xmin;
+
+		/*
+		 * Since we currently do not freeze tuples when replaying data
+		 * changes, the replayed transactions should not precede the new value
+		 * of relfrozenxid. (Only transactions having XID >= snapshot->xmin
+		 * will be replayed.)
+		 *
+		 * Regarding multixacts, the corresponding cutoff is probably not
+		 * trivial to determine, however there should not be any multixacts in
+		 * the new relation at all: we do not replay tuple locking records an
+		 * that's ok because the tuple locks should no longer exist at the
+		 * moment we acquire AccessExclusiveLock on the old relation.
+		 */
+		if (TransactionIdFollows(*xid_cutoff, snapshot->xmin))
+			*xid_cutoff = snapshot->xmin;
 
 		PushActiveSnapshot(snapshot);
 	}
 
 	/*
 	 * Scan through the OldHeap, either in OldIndex order or sequentially;
-	 * copy each tuple into the NewHeap, or transiently to the tuplesort
+	 * copy each tuple into the rel_dst, or transiently to the tuplesort
 	 * module.  Note that we don't bother sorting dead tuples (they won't get
 	 * to the new table anyway).
 	 */
@@ -905,8 +941,12 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
 
 			/* End of the current range or wraparound? */
 			if (blkno >= range_end || blkno < range_start)
-				snapshot = finalize_block_range(chgcxt, blkno, range_start,
-												&range_end);
+				snapshot = finalize_block_range(OldHeap, rel_dst,
+												OldestXmin, *xid_cutoff,
+												*multi_cutoff,
+												chgcxt, blkno, range_start,
+												&range_end, &rwstate,
+												&range_start_new);
 
 			/* Finally check the tuple visibility. */
 			LockBuffer(buf, BUFFER_LOCK_SHARE);
@@ -942,7 +982,7 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
 			if (!concurrent)
 				reform_and_rewrite_tuple(slot, reform_slot, rwstate);
 			else
-				heap_insert_for_repack(chgcxt, slot, reform_slot);
+				heap_insert_for_repack(chgcxt, slot, reform_slot, rwstate);
 
 			/*
 			 * In indexscan mode and also VACUUM FULL, report increase in
@@ -958,6 +998,13 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
 	{
 		XLogRecPtr	end_of_wal;
 
+		/* Write out any remaining tuples, and fsync if needed */
+		end_heap_rewrite(rwstate);
+
+		/* Finalize the last range in the new relation. */
+		range_end_new = RelationGetNumberOfBlocks(rel_dst);
+		update_identity_index(chgcxt, range_start_new, range_end_new);
+
 		/*
 		 * Process the changes belonging to the last range.
 		 */
@@ -969,11 +1016,16 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
 
 		/*
 		 * There was an active transaction snapshot on entry, so push one
-		 * before return.
+		 * before return. While there is no active snapshot, also invalidate
+		 * the catalog snapshot so that the xmin horizons for VACUUM can
+		 * advance.
 		 */
 		PopActiveSnapshot();
+		InvalidateCatalogSnapshot();
+		Assert(!TransactionIdIsValid(MyProc->xmin));
+		Assert(!TransactionIdIsValid(MyProc->xid));
+		Assert(!HaveRegisteredOrActiveSnapshot());
 		PushActiveSnapshot(GetTransactionSnapshot());
-
 	}
 
 	if (indexScan != NULL)
@@ -1040,9 +1092,70 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
 
 	ExecDropSingleTupleTableSlot(reform_slot);
 
-	/* Write out any remaining tuples, and fsync if needed */
-	if (rwstate)
+	if (!concurrent)
+	{
+		/*
+		 * In the CONCURRENTLY case, we had to do away with the rewrite state
+		 * earlier.
+		 */
 		end_heap_rewrite(rwstate);
+	}
+}
+
+/*
+ * Scan range of the new / auxiliary relation and insert all the tuples into
+ * the identity index. range_end is the first block of the next range.
+ */
+static void
+update_identity_index(ChangeContext *chgcxt, BlockNumber range_start,
+					  BlockNumber range_end)
+{
+	RepackDest *dest;
+	BlockNumber first_block,
+				last_block;
+	ItemPointerData mintid,
+				maxtid;
+	TableScanDesc scan;
+	TupleTableSlot *slot;
+
+	/*
+	 * If an auxiliary table exists, it's the one we're copying the data into.
+	 */
+	if (chgcxt->cc_dest_aux)
+		dest = chgcxt->cc_dest_aux;
+	else
+		dest = &chgcxt->cc_dest;
+
+	first_block = range_start;
+
+	if (range_end > range_start)
+		last_block = range_end - 1;
+	else
+	{
+		Assert(range_start == range_end);
+
+		last_block = range_end;
+	}
+
+	ItemPointerSet(&mintid, first_block, FirstOffsetNumber);
+	ItemPointerSet(&maxtid, last_block, MaxOffsetNumber);
+
+	/* XXX flags? */
+	scan = table_beginscan_tidrange(dest->rel, SnapshotAny, &mintid, &maxtid,
+									0);
+	slot = table_slot_create(dest->rel, NULL);
+	while (table_scan_getnextslot(scan, ForwardScanDirection, slot))
+		ExecInsertIndexTuples(dest->rri, dest->estate, 0, slot, NIL, NULL);
+	ExecDropSingleTupleTableSlot(slot);
+	table_endscan(scan);
+
+	/*
+	 * Index insertion could have accessed catalog when checking constraints,
+	 * so make sure that we no longer block the progress of xmin horizons for
+	 * VACUUM. (It's ok to have a snapshot throughout range scan, so there's
+	 * no point in doing this invalidation more often.)
+	 */
+	InvalidateCatalogSnapshot();
 }
 
 /*
@@ -1055,20 +1168,47 @@ heapam_relation_copy_for_cluster(Relation OldHeap, Relation NewHeap,
  * first block beyond the new range.
  *
  * Return the snapshot for the scan of the new range.
+ *
+ * TODO Consider a structure to accommodate (most of) the arguments.
  */
 static Snapshot
-finalize_block_range(ChangeContext *chgcxt, BlockNumber cur,
-					 BlockNumber start, BlockNumber *end_p)
+finalize_block_range(Relation rel_old, Relation rel_dst,
+					 TransactionId oldest_xmin,
+					 TransactionId xid_cutoff,
+					 MultiXactId multi_cutoff,
+					 ChangeContext *chgcxt, BlockNumber cur,
+					 BlockNumber start, BlockNumber *end_p,
+					 RewriteState *rwstate_p,
+					 BlockNumber *range_start_dst_p)
 {
 	BlockNumber end = *end_p;
+	RewriteState rwstate = *rwstate_p;
 	XLogRecPtr	end_of_wal;
 	Snapshot	snapshot;
+	BlockNumber range_end_dst;
 
 	/*
 	 * Wait here when testing how snapshot is changed at page boundary.
 	 */
 	INJECTION_POINT("repack-concurrently-new-range", NULL);
 
+	/*
+	 * Make sure the data is flushed to file before changes can be applied to
+	 * it. (Nothing of it should be in shared buffers so far.)
+	 */
+	end_heap_rewrite(rwstate);
+
+	/*
+	 * Now that the data can be accessed via shared buffers, scan it and add
+	 * each tuple to the identity index - this is necessary to update the
+	 * concurrent data changes below. We could not do that earlier because
+	 * even insertion into index might need to fetch heap tuples, in order to
+	 * check unique or exclusion constraints.
+	 */
+	range_end_dst = RelationGetNumberOfBlocks(rel_dst);
+	update_identity_index(chgcxt, *range_start_dst_p, range_end_dst);
+	*range_start_dst_p = range_end_dst;
+
 	/*
 	 * Decode all the concurrent data changes committed so far before
 	 * requesting the next snapshot - these changes are applicable on top of
@@ -1101,6 +1241,7 @@ finalize_block_range(ChangeContext *chgcxt, BlockNumber cur,
 
 	/* See above. */
 	Assert(!TransactionIdIsValid(MyProc->xmin));
+	Assert(!TransactionIdIsValid(MyProc->xid));
 
 	/*
 	 * XXX It might be worth Assert(CatalogSnapshot == NULL) here, however
@@ -1123,8 +1264,20 @@ finalize_block_range(ChangeContext *chgcxt, BlockNumber cur,
 	 * next batch of decoded changes.
 	 */
 	snapshot = repack_get_snapshot(chgcxt);
+
+	Assert(TransactionIdFollowsOrEquals(snapshot->xmin,
+										chgcxt->cc_last_snapshot_xmin));
+	chgcxt->cc_last_snapshot_xmin = snapshot->xmin;
+
 	PushActiveSnapshot(snapshot);
 
+	/*
+	 * Prepare for bulk insert of the next set of tuples. We rely on it to
+	 * start on a new page, even if the last existing page is not full.
+	 */
+	*rwstate_p = begin_heap_rewrite(rel_old, rel_dst, oldest_xmin, xid_cutoff,
+									multi_cutoff, true);
+
 	return snapshot;
 }
 
@@ -2554,6 +2707,64 @@ reform_and_rewrite_tuple(TupleTableSlot *src, TupleTableSlot *reform,
 		heap_freetuple(newtuple);
 }
 
+/*
+ * Insert tuple when processing REPACK CONCURRENTLY.
+ *
+ * 'reform' is a slot to use for tuple "reforming", typically to get set
+ * values of dropped columns to NULL.
+ *
+ * We pass the NO_LOGICAL flag to heap_insert() in order to skip logical
+ * decoding: as soon as REPACK CONCURRENTLY swaps the relation files, it drops
+ * this relation, so no logical replication subscription should need the data.
+ */
+static void
+heap_insert_for_repack(ChangeContext *chgcxt, TupleTableSlot *src,
+					   TupleTableSlot *reform, RewriteState rwstate)
+{
+	HeapTuple	tuple,
+				new_tuple;
+	TransactionId xid;
+	bool		shouldFree,
+				shouldFreeNew;
+	TupleTableSlot *slot;
+	bool		freeze;
+
+	if (chgcxt->cc_dest_aux)
+	{
+		/* Will freeze when copying data to the new table. */
+		freeze = false;
+	}
+	else
+		freeze = true;
+
+	Assert(TTS_IS_BUFFERTUPLE(src));
+	tuple = ExecFetchSlotHeapTuple(src, false, &shouldFree);
+	xid = HeapTupleHeaderGetXmin(tuple->t_data);
+	if (reform != NULL && tuple_needs_reform(tuple, src->tts_tupleDescriptor))
+	{
+		clear_dropped_attributes(tuple, reform);
+		slot = reform;
+	}
+	else
+		slot = src;
+
+	/* Make sure we have a copy of the tuple, and set its XID. */
+	new_tuple = ExecFetchSlotHeapTuple(slot, true, &shouldFreeNew);
+	HeapTupleHeaderSetXmin(new_tuple->t_data, xid);
+
+	/* Perform the insertion. */
+	rewrite_heap_tuple_no_chains(rwstate, tuple, new_tuple, freeze);
+
+	/* The insertion shouldn't have caused XID assignment. */
+	Assert(!TransactionIdIsValid(GetCurrentTransactionIdIfAny()));
+
+	/* Cleanup. */
+	if (shouldFree)
+		heap_freetuple(tuple);
+	if (shouldFreeNew)
+		heap_freetuple(new_tuple);
+}
+
 /*
  * Check visibility of the tuple.
  */
diff --git a/src/backend/access/heap/heapam_visibility.c b/src/backend/access/heap/heapam_visibility.c
index 361b76e5065..f37e4848667 100644
--- a/src/backend/access/heap/heapam_visibility.c
+++ b/src/backend/access/heap/heapam_visibility.c
@@ -1363,6 +1363,65 @@ HeapTupleSatisfiesNonVacuumable(HeapTuple htup, Snapshot snapshot,
 	return res != HEAPTUPLE_DEAD;
 }
 
+/*
+ * HeapTupleSatisfiesNewHeap
+ *		Consider all transactions committed or current.
+ *
+ * See SNAPSHOT_NEW_HEAP's definition for the intended behaviour.
+ *
+ */
+static bool
+HeapTupleSatisfiesNewHeap(HeapTuple htup, Snapshot snapshot, Buffer buffer)
+{
+	HeapTupleHeader tuple = htup->t_data;
+
+	Assert(ItemPointerIsValid(&htup->t_self));
+	Assert(htup->t_tableOid != InvalidOid);
+
+	/* xmin should always be there. */
+	Assert(TransactionIdIsValid(HeapTupleHeaderGetXmin(tuple)));
+
+	/*
+	 * No one should have the chance to set XMIN_INVALID until REPACK has
+	 * finished, and we do not need it.
+	 */
+	Assert(!HeapTupleHeaderXminInvalid(tuple));
+
+	/*
+	 * Unlike that, XMIN_COMMITTED might have been set earlier by REPACK
+	 * itself, but we don't need it here.
+	 */
+
+	/*
+	 * Set XMIN_COMMITTED to make the next checks (by any snapshot) faster.
+	 *
+	 * TODO Set the flag in the initial load and in
+	 * apply_concurrent_changes().
+	 */
+	SetHintBits(tuple, buffer, HEAP_XMIN_COMMITTED,
+				HeapTupleHeaderGetRawXmax(tuple));
+
+	/* Inserted tuples have XMAX_INVALID set. */
+	if (tuple->t_infomask & HEAP_XMAX_INVALID)
+		return true;
+
+	/*
+	 * REPACK could have set XMAX_COMMITTED during UPDATE or DELETE, or below.
+	 */
+	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
+		return false;
+
+	if (!TransactionIdIsValid(HeapTupleHeaderGetRawXmax(tuple)))
+		return true;
+
+	/*
+	 * Set XMAX_COMMITTED to make the next checks faster.
+	 */
+	SetHintBits(tuple, buffer, HEAP_XMAX_COMMITTED,
+				HeapTupleHeaderGetRawXmax(tuple));
+
+	return false;
+}
 
 /*
  * HeapTupleIsSurelyDead
@@ -1747,6 +1806,9 @@ HeapTupleSatisfiesVisibility(HeapTuple htup, Snapshot snapshot, Buffer buffer)
 			return HeapTupleSatisfiesHistoricMVCC(htup, snapshot, buffer);
 		case SNAPSHOT_NON_VACUUMABLE:
 			return HeapTupleSatisfiesNonVacuumable(htup, snapshot, buffer);
+		case SNAPSHOT_NEW_HEAP:
+			return HeapTupleSatisfiesNewHeap(htup, snapshot, buffer);
+
 	}
 
 	return false;				/* keep compiler quiet */
diff --git a/src/backend/access/heap/heaptoast.c b/src/backend/access/heap/heaptoast.c
index 03f885a25b0..4a6a674b80e 100644
--- a/src/backend/access/heap/heaptoast.c
+++ b/src/backend/access/heap/heaptoast.c
@@ -40,7 +40,8 @@
  * ----------
  */
 void
-heap_toast_delete(Relation rel, HeapTuple oldtup, bool is_speculative)
+heap_toast_delete(Relation rel, HeapTuple oldtup, bool is_speculative,
+				  TransactionId xid)
 {
 	TupleDesc	tupleDesc;
 	Datum		toast_values[MaxHeapAttributeNumber];
@@ -70,7 +71,8 @@ heap_toast_delete(Relation rel, HeapTuple oldtup, bool is_speculative)
 	heap_deform_tuple(oldtup, tupleDesc, toast_values, toast_isnull);
 
 	/* Do the real work. */
-	toast_delete_external(rel, toast_values, toast_isnull, is_speculative);
+	toast_delete_external(rel, toast_values, toast_isnull, is_speculative,
+						  xid);
 }
 
 
@@ -84,6 +86,7 @@ heap_toast_delete(Relation rel, HeapTuple oldtup, bool is_speculative)
  *	newtup: the candidate new tuple to be inserted
  *	oldtup: the old row version for UPDATE, or NULL for INSERT
  *	options: options to be passed to heap_insert() for toast rows
+ *	rwstate: if valid, use raw_heap_insert()
  * Result:
  *	either newtup if no toasting is needed, or a palloc'd modified tuple
  *	that is what should actually get stored
@@ -94,7 +97,7 @@ heap_toast_delete(Relation rel, HeapTuple oldtup, bool is_speculative)
  */
 HeapTuple
 heap_toast_insert_or_update(Relation rel, HeapTuple newtup, HeapTuple oldtup,
-							uint32 options)
+							RewriteState rwstate, uint32 options)
 {
 	HeapTuple	result_tuple;
 	TupleDesc	tupleDesc;
@@ -109,6 +112,7 @@ heap_toast_insert_or_update(Relation rel, HeapTuple newtup, HeapTuple oldtup,
 	Datum		toast_oldvalues[MaxHeapAttributeNumber];
 	ToastAttrInfo toast_attr[MaxHeapAttributeNumber];
 	ToastTupleContext ttc;
+	TransactionId xid;
 
 	/*
 	 * Ignore the INSERT_SPECULATIVE option. Speculative insertions/super
@@ -156,6 +160,13 @@ heap_toast_insert_or_update(Relation rel, HeapTuple newtup, HeapTuple oldtup,
 	ttc.ttc_attr = toast_attr;
 	toast_tuple_init(&ttc);
 
+	/*
+	 * raw_heap_insert() may be needed for insertion into the TOAST table. In
+	 * that case, visibility information will be retrieved from 'newtup'.
+	 */
+	ttc.ttc_rwstate = rwstate;
+	ttc.ttc_tup_main = newtup;
+
 	/* ----------
 	 * Compress and/or save external until data fits into target length
 	 *
@@ -330,7 +341,11 @@ heap_toast_insert_or_update(Relation rel, HeapTuple newtup, HeapTuple oldtup,
 	else
 		result_tuple = newtup;
 
-	toast_tuple_cleanup(&ttc);
+	if (options & TABLE_REUSE_XID)
+		xid = HeapTupleHeaderGetXmin(newtup->t_data);
+	else
+		xid = InvalidTransactionId; /* The current transaction. */
+	toast_tuple_cleanup(&ttc, xid);
 
 	return result_tuple;
 }
diff --git a/src/backend/access/heap/rewriteheap.c b/src/backend/access/heap/rewriteheap.c
index 0ccd392c3dc..809dfba1b55 100644
--- a/src/backend/access/heap/rewriteheap.c
+++ b/src/backend/access/heap/rewriteheap.c
@@ -107,6 +107,7 @@
 #include "access/heapam.h"
 #include "access/heapam_xlog.h"
 #include "access/heaptoast.h"
+#include "access/multixact.h"
 #include "access/rewriteheap.h"
 #include "access/transam.h"
 #include "access/xact.h"
@@ -119,6 +120,7 @@
 #include "storage/bufmgr.h"
 #include "storage/bulk_write.h"
 #include "storage/fd.h"
+#include "storage/lmgr.h"
 #include "storage/procarray.h"
 #include "utils/memutils.h"
 #include "utils/rel.h"
@@ -151,6 +153,12 @@ typedef struct RewriteStateData
 	HTAB	   *rs_old_new_tid_map; /* unmatched B tuples */
 	HTAB	   *rs_logical_mappings;	/* logical remapping files */
 	uint32		rs_num_rewrite_mappings;	/* # in memory mappings */
+
+	/*
+	 * If this is initialized, raw_heap_insert() is also used for TOAST
+	 * relation.
+	 */
+	struct RewriteStateData *toast;
 } RewriteStateData;
 
 /*
@@ -211,6 +219,11 @@ typedef struct RewriteMappingDataEntry
 
 
 /* prototypes for internal functions */
+static RewriteState begin_heap_rewrite_common(Relation old_heap,
+											  Relation new_heap,
+											  TransactionId oldest_xmin,
+											  TransactionId freeze_xid,
+											  MultiXactId cutoff_multi);
 static void raw_heap_insert(RewriteState state, HeapTuple tup);
 
 /* internal logical remapping prototypes */
@@ -227,18 +240,19 @@ static void logical_end_heap_rewrite(RewriteState state);
  * oldest_xmin	xid used by the caller to determine which tuples are dead
  * freeze_xid	xid before which tuples will be frozen
  * cutoff_multi	multixact before which multis will be removed
+ * no_chains	only raw insert (and freezing), do not care of HOT chains
  *
  * Returns an opaque RewriteState, allocated in current memory context,
  * to be used in subsequent calls to the other functions.
  */
 RewriteState
 begin_heap_rewrite(Relation old_heap, Relation new_heap, TransactionId oldest_xmin,
-				   TransactionId freeze_xid, MultiXactId cutoff_multi)
+				   TransactionId freeze_xid, MultiXactId cutoff_multi,
+				   bool no_chains)
 {
-	RewriteState state;
 	MemoryContext rw_cxt;
 	MemoryContext old_cxt;
-	HASHCTL		hash_ctl;
+	RewriteState state;
 
 	/*
 	 * To ease cleanup, make a separate context that will contain the
@@ -249,9 +263,99 @@ begin_heap_rewrite(Relation old_heap, Relation new_heap, TransactionId oldest_xm
 								   ALLOCSET_DEFAULT_SIZES);
 	old_cxt = MemoryContextSwitchTo(rw_cxt);
 
+	state = begin_heap_rewrite_common(old_heap, new_heap, oldest_xmin,
+									  freeze_xid, cutoff_multi);
+	state->rs_cxt = rw_cxt;
+
+	if (!no_chains)
+	{
+		HASHCTL		hash_ctl;
+
+		/* Initialize hash tables used to track update chains */
+		hash_ctl.keysize = sizeof(TidHashKey);
+		hash_ctl.entrysize = sizeof(UnresolvedTupData);
+		hash_ctl.hcxt = state->rs_cxt;
+
+		state->rs_unresolved_tups =
+			hash_create("Rewrite / Unresolved ctids",
+						128,	/* arbitrary initial size */
+						&hash_ctl,
+						HASH_ELEM | HASH_BLOBS | HASH_CONTEXT);
+
+		hash_ctl.entrysize = sizeof(OldToNewMappingData);
+
+		state->rs_old_new_tid_map =
+			hash_create("Rewrite / Old to new tid map",
+						128,	/* arbitrary initial size */
+						&hash_ctl,
+						HASH_ELEM | HASH_BLOBS | HASH_CONTEXT);
+
+		logical_begin_heap_rewrite(state);
+	}
+	else
+	{
+		Oid			toastid;
+
+		/*
+		 * The current user of this mode, REPACK (CONCURRENTLY), does not want
+		 * XID assigned at all, so "raw insert" is also used for TOAST.
+		 *
+		 * XXX "raw insert" would be helpful for REPACK w/o CONCURRENTLY too,
+		 * as it writes the whole pages to WAL. The problem here is that it
+		 * might check the existence of chunk OIDs in the new TOAST relation
+		 * (see the hacks with rd_toastoid in toast_save_datum()), and that
+		 * doesn't work while the rewrite is still in progress: the relation
+		 * pages are not guaranteed to be flushed to disk (and read into
+		 * shared buffers) before the end of the rewrite.
+		 */
+		toastid = new_heap->rd_rel->reltoastrelid;
+		if (OidIsValid(toastid))
+		{
+			Oid			toastid_old;
+			Relation	toast_rel;
+			Relation	toast_rel_old = NULL;
+
+			/* New relation's TOAST should already be locked. */
+			Assert(CheckRelationOidLockedByMe(toastid, AccessExclusiveLock,
+											  false));
+			toast_rel = table_open(toastid, NoLock);
+
+			toastid_old = old_heap ? old_heap->rd_rel->reltoastrelid :
+				InvalidTransactionId;
+			if (OidIsValid(toastid_old))
+			{
+				/*
+				 * Currently we do not lock the old relation's TOAST. Use the
+				 * same lock mode we use for the parent relation.
+				 */
+				toast_rel_old = table_open(toastid_old,
+										   ShareUpdateExclusiveLock);
+			}
+
+			/* Create the state for TOAST insertions. */
+			state->toast = begin_heap_rewrite_common(toast_rel_old,
+													 toast_rel,
+													 oldest_xmin,
+													 freeze_xid,
+													 cutoff_multi);
+		}
+	}
+
+	MemoryContextSwitchTo(old_cxt);
+
+	return state;
+}
+
+static RewriteState
+begin_heap_rewrite_common(Relation old_heap, Relation new_heap,
+						  TransactionId oldest_xmin,
+						  TransactionId freeze_xid, MultiXactId cutoff_multi)
+
+{
+	RewriteState state;
+
 	/* Create and fill in the state struct */
 	state = palloc0_object(RewriteStateData);
-
 	state->rs_old_rel = old_heap;
 	state->rs_new_rel = new_heap;
 	state->rs_buffer = NULL;
@@ -260,32 +364,8 @@ begin_heap_rewrite(Relation old_heap, Relation new_heap, TransactionId oldest_xm
 	state->rs_oldest_xmin = oldest_xmin;
 	state->rs_freeze_xid = freeze_xid;
 	state->rs_cutoff_multi = cutoff_multi;
-	state->rs_cxt = rw_cxt;
 	state->rs_bulkstate = smgr_bulk_start_rel(new_heap, MAIN_FORKNUM);
 
-	/* Initialize hash tables used to track update chains */
-	hash_ctl.keysize = sizeof(TidHashKey);
-	hash_ctl.entrysize = sizeof(UnresolvedTupData);
-	hash_ctl.hcxt = state->rs_cxt;
-
-	state->rs_unresolved_tups =
-		hash_create("Rewrite / Unresolved ctids",
-					128,		/* arbitrary initial size */
-					&hash_ctl,
-					HASH_ELEM | HASH_BLOBS | HASH_CONTEXT);
-
-	hash_ctl.entrysize = sizeof(OldToNewMappingData);
-
-	state->rs_old_new_tid_map =
-		hash_create("Rewrite / Old to new tid map",
-					128,		/* arbitrary initial size */
-					&hash_ctl,
-					HASH_ELEM | HASH_BLOBS | HASH_CONTEXT);
-
-	MemoryContextSwitchTo(old_cxt);
-
-	logical_begin_heap_rewrite(state);
-
 	return state;
 }
 
@@ -300,16 +380,20 @@ end_heap_rewrite(RewriteState state)
 	HASH_SEQ_STATUS seq_status;
 	UnresolvedTup unresolved;
 
-	/*
-	 * Write any remaining tuples in the UnresolvedTups table. If we have any
-	 * left, they should in fact be dead, but let's err on the safe side.
-	 */
-	hash_seq_init(&seq_status, state->rs_unresolved_tups);
-
-	while ((unresolved = hash_seq_search(&seq_status)) != NULL)
+	if (state->rs_unresolved_tups)
 	{
-		ItemPointerSetInvalid(&unresolved->tuple->t_data->t_ctid);
-		raw_heap_insert(state, unresolved->tuple);
+		/*
+		 * Write any remaining tuples in the UnresolvedTups table. If we have
+		 * any left, they should in fact be dead, but let's err on the safe
+		 * side.
+		 */
+		hash_seq_init(&seq_status, state->rs_unresolved_tups);
+
+		while ((unresolved = hash_seq_search(&seq_status)) != NULL)
+		{
+			ItemPointerSetInvalid(&unresolved->tuple->t_data->t_ctid);
+			raw_heap_insert(state, unresolved->tuple);
+		}
 	}
 
 	/* Write the last page, if any */
@@ -318,10 +402,29 @@ end_heap_rewrite(RewriteState state)
 		smgr_bulk_write(state->rs_bulkstate, state->rs_blockno, state->rs_buffer, true);
 		state->rs_buffer = NULL;
 	}
-
 	smgr_bulk_finish(state->rs_bulkstate);
 
-	logical_end_heap_rewrite(state);
+	/* The same for TOAST */
+	if (state->toast)
+	{
+		RewriteState toast = state->toast;
+
+		if (toast->rs_buffer)
+		{
+			smgr_bulk_write(toast->rs_bulkstate, toast->rs_blockno,
+							toast->rs_buffer, true);
+			toast->rs_buffer = NULL;
+		}
+		smgr_bulk_finish(toast->rs_bulkstate);
+
+		/* Close relation(s) opened by begin_heap_rewrite(). */
+		table_close(toast->rs_new_rel, NoLock);
+		if (toast->rs_old_rel)
+			table_close(toast->rs_old_rel, ShareUpdateExclusiveLock);
+	}
+
+	if (state->rs_logical_rewrite)
+		logical_end_heap_rewrite(state);
 
 	/* Deleting the context frees everything */
 	MemoryContextDelete(state->rs_cxt);
@@ -350,30 +453,13 @@ rewrite_heap_tuple(RewriteState state,
 
 	old_cxt = MemoryContextSwitchTo(state->rs_cxt);
 
-	/*
-	 * Copy the original tuple's visibility information into new_tuple.
-	 *
-	 * XXX we might later need to copy some t_infomask2 bits, too? Right now,
-	 * we intentionally clear the HOT status bits.
-	 */
-	memcpy(&new_tuple->t_data->t_choice.t_heap,
-		   &old_tuple->t_data->t_choice.t_heap,
-		   sizeof(HeapTupleFields));
-
-	new_tuple->t_data->t_infomask &= ~HEAP_XACT_MASK;
-	new_tuple->t_data->t_infomask2 &= ~HEAP2_XACT_MASK;
-	new_tuple->t_data->t_infomask |=
-		old_tuple->t_data->t_infomask & HEAP_XACT_MASK;
+	rewrite_copy_visibility_info(new_tuple, old_tuple);
 
 	/*
 	 * While we have our hands on the tuple, we may as well freeze any
 	 * eligible xmin or xmax, so that future VACUUM effort can be saved.
 	 */
-	heap_freeze_tuple(new_tuple->t_data,
-					  state->rs_old_rel->rd_rel->relfrozenxid,
-					  state->rs_old_rel->rd_rel->relminmxid,
-					  state->rs_freeze_xid,
-					  state->rs_cutoff_multi);
+	rewrite_freeze_tuple(state, new_tuple);
 
 	/*
 	 * Invalid ctid means that ctid should point to the tuple itself. We'll
@@ -534,6 +620,24 @@ rewrite_heap_tuple(RewriteState state,
 	MemoryContextSwitchTo(old_cxt);
 }
 
+/*
+ * Like rewrite_heap_tuple(), but do not care about hot chains. The user
+ * should have used the appropriate snapshot to pick at most one tuple of the
+ * chain - this is typical for REPACK (CONCURRENTLY).
+ */
+void
+rewrite_heap_tuple_no_chains(RewriteState state, HeapTuple old_tuple,
+							 HeapTuple new_tuple, bool freeze)
+{
+	if (new_tuple != old_tuple)
+		rewrite_copy_visibility_info(new_tuple, old_tuple);
+
+	if (freeze)
+		rewrite_freeze_tuple(state, new_tuple);
+
+	raw_heap_insert(state, new_tuple);
+}
+
 /*
  * Register a dead tuple with an ongoing rewrite. Dead tuples are not
  * copied to the new table, but we still make note of them so that we
@@ -628,7 +732,7 @@ raw_heap_insert(RewriteState state, HeapTuple tup)
 		options |= HEAP_INSERT_NO_LOGICAL;
 
 		heaptup = heap_toast_insert_or_update(state->rs_new_rel, tup, NULL,
-											  options);
+											  state->toast, options);
 	}
 	else
 		heaptup = tup;
@@ -704,6 +808,47 @@ raw_heap_insert(RewriteState state, HeapTuple tup)
 		heap_freetuple(heaptup);
 }
 
+/*
+ * Freeze tuple. 'old_tuple' provides the initial visibility information.
+ */
+void
+rewrite_freeze_tuple(RewriteState state, HeapTuple tuple)
+{
+	TransactionId relfrozenxid = InvalidTransactionId;
+	MultiXactId relminmxid = InvalidMultiXactId;
+
+	/* The old relation may be missing if dealing with TOAST. */
+	if (state->rs_old_rel)
+	{
+		relfrozenxid = state->rs_old_rel->rd_rel->relfrozenxid;
+		relminmxid = state->rs_old_rel->rd_rel->relminmxid;
+	}
+
+	heap_freeze_tuple(tuple->t_data, relfrozenxid, relminmxid,
+					  state->rs_freeze_xid,
+					  state->rs_cutoff_multi);
+}
+
+/*
+ * Copy the old tuple's visibility information into the new tuple.
+ */
+void
+rewrite_copy_visibility_info(HeapTuple new_tuple, HeapTuple old_tuple)
+{
+	/*
+	 * XXX we might later need to copy some t_infomask2 bits, too? Right now,
+	 * we intentionally clear the HOT status bits.
+	 */
+	memcpy(&new_tuple->t_data->t_choice.t_heap,
+		   &old_tuple->t_data->t_choice.t_heap,
+		   sizeof(HeapTupleFields));
+
+	new_tuple->t_data->t_infomask &= ~HEAP_XACT_MASK;
+	new_tuple->t_data->t_infomask2 &= ~HEAP2_XACT_MASK;
+	new_tuple->t_data->t_infomask |=
+		old_tuple->t_data->t_infomask & HEAP_XACT_MASK;
+}
+
 /* ------------------------------------------------------------------------
  * Logical rewrite support
  *
diff --git a/src/backend/access/table/tableam.c b/src/backend/access/table/tableam.c
index 68ff0966f1c..43b853d949e 100644
--- a/src/backend/access/table/tableam.c
+++ b/src/backend/access/table/tableam.c
@@ -319,6 +319,7 @@ simple_table_tuple_delete(Relation rel, ItemPointer tid, Snapshot snapshot)
 	TM_FailureData tmfd;
 
 	result = table_tuple_delete(rel, tid,
+								InvalidTransactionId,
 								GetCurrentCommandId(true),
 								0, snapshot, InvalidSnapshot,
 								true /* wait for commit */ ,
